#!/python26/python

# For each demo file in the example directory, compile it thus:
#  gcc -I../src -o file.exe file.c ../src/libapp.a /MinGW/lib/libgdi32.a
# Uses full paths.

import os, sys, string

project_base	=     '/apps/app/'
source_base		= project_base + 'src/'
object_base		= source_base +       'objects/'
example_base	= project_base + 'examples/'
gcc_base		=    '/MinGW/'
gcc_inc			= gcc_base + 'include/'
gcc_bin			= gcc_base + 'bin/'
gcc				= gcc_bin +       'gcc'
make_static_lib	= gcc_bin +       'ar rc'
gcc_lib			= gcc_base + 'lib/'
lib_graphics	= gcc_lib +       'libgdi32.a'
gcc_flags		= '-O2 -Wall'
gcc_compile		= '-c'
gcc_outfile		= '-o'
#no_console		= '-mwindows'	# deprecated MinGW option
no_console		= '-Wl,-subsystem,windows'
target_platform	= 'win32'
static_lib		= source_base + 'libapp.a'
example_dirs	= ['.']
include_dirs	= [source_base, example_base]
link_libs		= [static_lib, lib_graphics]
verbose			= 1
pretend			= 0

def main():
	args = sys.argv[1:]
	if len(args) == 0:
		args.append('all')
	inc = ''
	for id in include_dirs:
		inc = inc + '-I' + id + ' '

	for d in example_dirs:
		base = example_base
		path = base + d + '/'
		files = os.listdir(path)
		for file in files:
			if file[-2:] == '.c':
				name = file[:-2]
				if d != '.':
					folder = path
				else:
					folder = base
				if 'all' in args:
					pass
				elif (name in args) or ((name + '.exe') in args):
					pass
				else:
					continue	# skip
				build_exe(folder, name, '.c', inc)
				
def build_exe(filepath, name, ext, include_paths):
	cmd = gcc
	cmd = cmd + ' ' + gcc_flags
	cmd = cmd + ' ' + include_paths
	cmd = cmd + ' ' + no_console
	cmd = cmd + ' ' + gcc_outfile + ' ' + name + '.exe'
	cmd = cmd + ' ' + filepath + name + ext
	for lib in link_libs:
		cmd = cmd + ' ' + lib
	perform(cmd)

def perform(cmd):
	if verbose:
		print cmd
	if pretend:
		return
	os.system(cmd)
	
if __name__ == '__main__':
	main()
